// Library

#include <ESP8266WiFi.h>
#include <PubSubClient.h>


// WiFi settings
const char* ssid = "XXXXXXXXXXXX";
const char* password = "XXXXXXXXXXXXXXX";

String clientName = "name";


#define PINout 5

String topic = "/home/button/";
char* server = "192.168.178.74";
String t_st = WiFi.macAddress();


WiFiClient wifiClient;
PubSubClient client(server, 1883, wifiClient);



void callback(char* topic, byte* payload, unsigned int length) {
  // handle message arrived
}

void status() {
  switch ( client.state() )
  {
    case -4:
      Serial.println("-4 : MQTT_CONNECTION_TIMEOUT - the server didn't respond within the keepalive time");
      break;
    case -3:
      Serial.println("-3 : MQTT_CONNECTION_LOST - the network connection was broken");
      break;
    case -2:
      Serial.println("-2 : MQTT_CONNECT_FAILED - the network connection failed");
      break;
    case -1:
      Serial.println("-1 : MQTT_DISCONNECTED - the client is disconnected cleanly");
      break;

    case 0:
      Serial.println("0 : MQTT_CONNECTED - the cient is connected");
      break;
    case 1:
      Serial.println("1 : MQTT_CONNECT_BAD_PROTOCOL - the server doesn't support the requested version of MQTT");
      break;
    case 2:
      Serial.println("2 : MQTT_CONNECT_BAD_CLIENT_ID - the server rejected the client identifier");
      break;
    case 3:
      Serial.println("3 : MQTT_CONNECT_UNAVAILABLE - the server was unable to accept the connection");
      break;
    case 4:
      Serial.println("4 : MQTT_CONNECT_BAD_CREDENTIALS - the username/password were rejected");
      break;
      break;
    case 5:
      Serial.println("5 : MQTT_CONNECT_UNAUTHORIZED - the client was not authorized to connect");
      break;
    default:
      break;
  }

}

void setup()
{
  pinMode(PINout, OUTPUT);           // set pin to input
  digitalWrite(PINout, HIGH);
  // Serial
  Serial.begin(9600);

  Serial.println("ESP8266 in normal mode");

  // Connect to WiFi
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  WiFi.config(IPAddress(192, 168, 178, 102), IPAddress(192, 168, 178, 1), IPAddress(255, 255, 255, 0), IPAddress(192, 168, 178, 1));
  while (WiFi.status() != WL_CONNECTED) {
    delay(300);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");

  // Print the IP address
  Serial.println(WiFi.localIP());



  if (client.connect((char*) clientName.c_str())) {
    Serial.println("Connected to MQTT broker");

  }
  else {
    status();
    Serial.println("MQTT connect failed");
    Serial.println("Will reset and try again...");
    abort();
  }



  if (client.publish((char*) topic.c_str(), (char*) t_st.c_str())) {
    Serial.println("Publisched");

  }

  yield();

  digitalWrite(PINout, LOW);



}


void loop()
{
  delay(300);
  Serial.print(".");
}
